	.386
	.model flat


;
; Small-C Run Time Library for MS/PC-DOS
;

_TEXT	SEGMENT

        public  _CCARGC
_CCARGC:
        xor     eax,eax
        movsx   eax,cl
        ret


;
; Test if Secondary (BX) <oper> Primary (AX)
;-------------------------- MASM version
compare macro   name, cond
        public  __&name
__&name:
        cmp     eax,ebx
        j&cond  true
        xor     eax,eax   ; returns zero
        ret
        endm
IF 0
;-------------------------- ASM version
compare macro   name, cond
        public  __?1
__?1:
        cmp     ax,bx
        j?2     true
        xor     ax,ax   ; returns zero
        ret
        endm
;--------------------------
ENDIF

        compare ult,a
        compare ugt,b
        compare ule,ae
        compare uge,be
        compare eq,e
        compare ne,ne
        compare lt,g
        compare gt,l
        compare le,ge
        compare ge,le

;
; Logical Negate of Primary
;
        public  __lneg
__lneg:
        or      eax,eax
        jnz     false
true:   mov     eax,1    ; returns one
        ret
false:  xor     eax,eax   ; returns zero
        ret
;
;
; execute "switch" statement
;
;  ax  =  switch value
; (sp) -> switch table
;         dw addr1, value1
;         dw addr2, value2
;         ...
;         dw 0
;        [jmp default]
;         continuation
;
        public  __switch
__switch:
        pop     ebx              ; bx -> switch table
        jmp     skip            ; skip the pre-increment
back:
        add     ebx,8
skip:   mov     ecx,[ebx]
        jcxz    default         ; end of table -- jump out
        cmp     eax,[ebx+4]
        jnz     back
        jmp     ecx              ; match -- jump to case
default:
        add     ebx,4
        jmp     ebx              ; jump to default/continuation

_TEXT	ends
        end
	END
